# Copyright 2008-2009 LShift Ltd

import sys
import os.path
import mercurial.config

globalconfig = None

def _getConf():
    global globalconfig
    if globalconfig is None:
        globalconfig = mercurial.config.config()
        globalconfig.read(os.path.expanduser("~/.mercurial-server"))
    return globalconfig

def configExists():
    try:
        _getConf()
        return True
    except:
        return False

def _getPath(name):
    return os.path.expanduser(_getConf()["paths"][name])

def _getPaths(name): 
    return [os.path.expanduser(p)
        for p in _getConf()["paths"][name].split(":")]

def getReposPath(): return _getPath("repos")
def getAuthorizedKeysPath(): return _getPath("authorized_keys")

def getKeysPaths(): return _getPaths("keys")
def getAccessPaths(): return _getPaths("access")

def getEnv(): return _getConf()["env"]

# Work out where we are, don't use config.
def setExePath():
    global _exePath
    _exePath = os.path.dirname(os.path.abspath(sys.argv[0]))

def getExePath():
    return _exePath

